package com.github.polpetta.mezzotre.orm.di;

import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import com.google.inject.Singleton;
import com.zaxxer.hikari.HikariConfig;
import io.jooby.Extension;
import io.jooby.ebean.EbeanModule;
import io.jooby.flyway.FlywayModule;
import io.jooby.hikari.HikariModule;
import javax.inject.Named;

public class Db extends AbstractModule {
  /**
   * Returns null. This allows to fetch the configuration from file rather than fetch from other
   * environment
   *
   * @return a {@link HikariConfig} configuration if possible
   */
  @Provides
  @Singleton
  public HikariConfig getHikariConfig() {
    return null;
  }

  @Provides
  @Singleton
  @Named("hikariPoolExtension")
  public Extension getHikariExtension() {
    return new HikariModule();
  }

  @Provides
  @Singleton
  @Named("flyWayMigrationExtension")
  public Extension getFlyWayMigrationExtension() {
    return new FlywayModule();
  }

  @Provides
  @Singleton
  @Named("ebeanExtension")
  public Extension getEbeanExtension() {
    return new EbeanModule();
  }
}
